---
title: KeyboardEvent.initKeyEvent()
slug: Web/API/KeyboardEvent/initKeyEvent
tags:
  - API
  - DOM
  - Deprecated
  - KeyboardEvent
  - Method
  - Reference
---
<p>{{ ApiRef("DOM Events") }}{{non-standard_header}}{{deprecated_header}}</p>

<p>The <strong><code>KeyboardEvent.initKeyEvent()</code></strong> method is used to initialize the value of an event created using {{domxref("document.createEvent")}}<code>("KeyboardEvent")</code>. Events initialized in this way must have been created with the {{domxref("document.createEvent")}}<code>("KeyboardEvent")</code> method. <code>initKeyEvent()</code> must be called to set the event before it is <a href="/en-US/docs/Web/API/EventTarget.dispatchEvent">dispatched</a>.</p>

<div class="note">
<p><strong>Do not use this method anymore, use the {{domxref("KeyboardEvent.KeyboardEvent", "KeyboardEvent()")}} constructor instead.</strong><br>
 <br>
 This method is based on early drafts of {{SpecName("DOM2 Events")}} and is implemented in Gecko-based browsers; other browsers implemented {{domxref("KeyboardEvent.initKeyboardEvent")}} based on early drafts of {{SpecName("DOM3 Events")}}. Favor the modern constructor structure as the only cross-browser way of building events.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>event</em>.initKeyEvent (<em>type</em>, <em>bubbles</em>, <em>cancelable</em>, <em>viewArg</em>,
                    <em>ctrlKeyArg</em>, <em>altKeyArg</em>, <em>shiftKeyArg</em>, <em>metaKeyArg</em>,
                    <em>keyCodeArg</em>, <em>charCodeArg</em>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em><code>type</code></em></dt>
 <dd>Is a {{domxref("DOMString")}} representing the type of event.</dd>
 <dt><em><code>bubbles</code></em></dt>
 <dd>Is a {{jsxref("Boolean")}} indicating whether the event should bubble up through the event chain or not (see <a href="/en/DOM/event.bubbles" title="en/DOM/event.bubbles">bubbles</a>).</dd>
 <dt><em><code>cancelable</code></em></dt>
 <dd>Is a {{jsxref("Boolean")}} i indicating whether the event can be canceled (see <a href="/en/DOM/event.cancelable" title="en/DOM/event.cancelable">cancelable</a>).</dd>
 <dt><em><code>viewArg</code></em></dt>
 <dd>Specifies the {{domxref("UIEvent.view")}}; this value may be <code>null</code>.</dd>
 <dt><em><code>ctrlKeyArg</code></em></dt>
 <dd>Is a {{jsxref("Boolean")}} that is <code>true</code> if the virtual key to be generated is a combination of keys containing the <kbd>Ctrl</kbd> key.</dd>
 <dt><em><code>altKeyArg</code></em></dt>
 <dd>Is a {{jsxref("Boolean")}} that is <code>true</code> if the virtual key to be generated is a combination of keys containing the <kbd>Alt</kbd> key.</dd>
 <dt><em><code>shiftKeyArg</code></em></dt>
 <dd>A {{jsxref("Boolean")}} that is <code>true</code> if the virtual key to be generated is a combination of keys containing the <kbd>Shift</kbd> key.</dd>
 <dt><em><code>metaKeyArg</code></em></dt>
 <dd>Is a {{jsxref("Boolean")}} that is <code>true</code> if the virtual key to be generated is a combination of keys containing the <kbd>Meta</kbd> key.</dd>
 <dt><em><code>keyCodeArg</code></em></dt>
 <dd>Is a <code>unsigned long</code> representing the virtual key code value of the key which was depressed, otherwise <code>0</code>. See {{ domxref("KeyboardEvent.keyCode") }} for the list of key codes.</dd>
 <dt><em><code>charCodeArg</code></em></dt>
 <dd>Is a <code>unsigned long</code> representingthe Unicode character associated with the depressed key otherwise <code>0</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var event = document.createEvent('KeyboardEvent'); // create a key event
// define the event
event.initKeyEvent("keypress",       // typeArg,
                   true,             // canBubbleArg,
                   true,             // cancelableArg,
                   null,             // viewArg,  Specifies UIEvent.view. This value may be null.
                   false,            // ctrlKeyArg,
                   false,            // altKeyArg,
                   false,            // shiftKeyArg,
                   false,            // metaKeyArg,
                    9,               // keyCodeArg,
                    0);              // charCodeArg);

document.getElementById('blah').dispatchEvent(event);
</pre>

<h2 id="Specifications">Specifications</h2>

<p>This implementation of keyboard events is based on the key events spec in the <a class="external" href="http://www.w3.org/TR/1999/WD-DOM-Level-2-19990923/events.html">early versions of DOM 2 Events</a>, later removed from that spec.</p>

<p>The <code>initKeyEvent</code> is the current Gecko equivalent of the DOM Level 3 Events (initially drafted and also deprecated in favor of {{domxref("KeyboardEvent.KeyboardEvent", "KeyboardEvent()")}} {{domxref("Keyboard.initKeyboardEvent()")}} method with the following arguments :</p>

<pre class="eval">typeArg of type DOMString
canBubbleArg of type boolean
cancelableArg of type boolean
viewArg of type views::AbstractView
keyIdentifierArg of type DOMString
keyLocationArg of type unsigned long
modifiersList of type DOMString);
</pre>
